﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#SingleInstance Force
SetBatchLines -1

/*
We will copy info from ExampleA into ExampleB if the Barcodes match, and save a Copy of ExampleB as ExampleC with the new info.
  This will assume that there are no duplicate Barcodes in ExampleA so we can use the info from the FIRST match found.
*/

Try ; To create an Excel COM object
	XL := ComObjCreate("Excel.Application") ; Excel lets you always create a new instance of the Application so this will never fail.
Catch ; Exit if failed.
	ExitApp

XL.DisplayAlerts := 0 ; this makes running in background much smoother, as no Alerts are shown.
;XL.Visible := True ; If you want excel to be visible and see everything happening (Although its fast) uncomment this line as it is hidden by default.

 ; Open Two Example Workbooks, must be full path to files, we build the full path using the Scripts Directory (Built-in A_ScriptDir) and the known filename.
aBook := XL.WorkBooks.Open(A_ScriptDir . "\ExampleA.xlsx") ; ExampleA has a list of "Barcodes" in column A, with "Info" on each in Column B
bBook := XL.WorkBooks.Open(A_ScriptDir . "\ExampleB.xlsx") ; ExampleB has a list of "Barcodes" in column A, with nothing else.

aSheet := aBook.Worksheets(1) ; use the first Worksheet in the workbook, this can be chosen by index 
bSheet := bBook.WorkSheets("Sheet1") ; or Name

 ; For each cell in ExampleB column A (Note -4162 is a "magic" number in excel that means 'end' getting the last occupied cell)
For cell in bSheet.Range("A1:A" . bSheet.Range("A1048576").End(-4162).Row) 
{
	foundCell := aSheet.Range("A:A").Find(cell.text) ; find barcode from ExampleB in ExampleA
	If (isObject(foundCell)) ; if Barcode was found then foundCell will be an object
		cell.Offset(,1).Value := foundCell.Offset(,1).Text ; Make Column B in ExampleB equal the info from ExampleA
}
 ; bBook.Save() if you are fine with overwriting ExampleB.xlsx, for the demo its easier to just save it as a new file I can delete.
bBook.SaveAs(A_ScriptDir . "\ExampleC.xlsx") 

 ; close workbooks
bBook.Close()
aBook.Close()

 ; quit Excel Application
XL.Quit()

 ; Free Object
XL := ""

 ; Exit the Script
ExitApp
